<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Command-Line Parser</TITLE>
<link href="suif1_106.html" rel=Next>
<link href="suif1_104.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_104.html">previous</A>, <A HREF="suif1_106.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC105" HREF="suif1_toc.html#TOC105">Command-Line Parser</A></H2>
<P>
<A NAME="IDX743"></A>
<A NAME="IDX744"></A>
<A NAME="IDX745"></A>
<A NAME="IDX746"></A>
<A NAME="IDX747"></A>

</P>
<P>
The SUIF library provides a generic interface for a command line parser.
The parser is defined and implemented in the files <TT>`cmdparse.h'</TT> and
<TT>`cmdparse.cc'</TT>.  The SUIF program can provide a structure that
contains a list of command line options, the type of arguments these
options can handle, and pointers to data where the argument values will
be stored.  The data locations will be initialized to default values
specified in the options table before parsing begins.  The
<CODE>parse_cmd_line</CODE> function is called with <CODE>argc</CODE>, <CODE>argv</CODE>,
the options table, and the number of options in the table.  If the
parser finds one of the options on the command line, the option (and its
argument, if any) are removed from <CODE>argv</CODE> and <CODE>argc</CODE> is
appropriately adjusted.  Thus when parsing is finished, <CODE>argv</CODE>
contains only unrecognized options (such as file names).

</P>
<P>
The following types of arguments are supported:

</P>
<DL COMPACT>

<DT><CODE>CLO_NOARG</CODE>
<DD>
No argument is expected.  The default value is 0.  If the argument is
present, the value becomes 1.

<DT><CODE>CLO_INT</CODE>
<DD>
A single integer is expected.

<DT><CODE>CLO_STRING</CODE>
<DD>
A single string is expected.

<DT><CODE>CLO_MULTI_STRING</CODE>
<DD>
A single string is expected for each occurrence of this option, but
the option can be repeated with different arguments.
</DL>

<P>
For example:

</P>

<PRE>
static boolean quiet;
static int size;
static cmd_line_option my_options[] = {
    { CLO_NOARG, "-quiet", "", &#38;quiet },
    { CLO_INT, "-size", "8", &#38;size }
};

parse_cmd_line(argc, argv, my_options,
               sizeof(my_options)/sizeof(cmd_line_option));
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_104.html">previous</A>, <A HREF="suif1_106.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
